/****************************************************\
|*Resident Evil: Half-Life - Mod                    *|
|*Created By: Sam Tsuki                             *|
|*                                                  *|
|* Have Fun,                                        *|
|*           Sam Tsuki                              *|
\****************************************************/

/*
Description:
This time they're not players... They're REAL Zombies and Head Crabs from Half-Life!
All map objectives are removed!
It's DARK!
When the game starts, everyone will be CT!
If a player camps for a couple of seconds a number of head crabs are spawned on him!
Each Zombie or Head Crab gives points controlled by cvars!
Humans need to servive the round!
When a human dies he will turn into a Zombie!
Zombies and Head Crabs won't attack Zombie players!
Zombie players can get points by killing Humans!
Humans can't use knifes but they can run faster when using them!
After the round ends the living human players will be awarded with some points!

CMDs:
say /points		//Shows the player's points
say /save		//Saves the player's points
say /load		//Loads the player's points
say /rehl_top15		//Shows top15 players with points
say /models		//Shows a menu to select a model

con rehl_toggle <0|1>	//ADMIN_BAN, Disable/Enable Resident Evil: Half-Life

CVARs:
rehl_switch 1		//Enables Resident Evil: Half-Life Mod
rehl_lightning 2	//0 = Normal Light, 1 = Pitch Black, 2 = Dark
rehl_freezetime 10	//Time before start and disable buying
rehl_roundtime 3	//Time the humans should survive to win
rehl_startmoney 16000	//The starting money
camp_time 15		//The time a player can stay in his place
move_dist 150		//The distnace a player should move to be not considered camipng
rehl_heanum 3		//Number of Head Crabs to be spawned on a camper
camp_headcrabs 1	//Enables Head Crabs on campers
knife_speed 300		//The speed of humans with knives
rehl_unlimitedammo 1	//Should players get unlimited ammo?
zombie_health 300	//Player zombie's health
zombie_gravity 0.5	//Player zombie's gravity
zombie_armor 100	//Player zombie's amror
zombie_speed 300	//Player zombie's speed
zombie_damage 2.5	//Player zombie's damage multiplier
zombie_vision 130	//Player zombie's vision zoom
zombie_tint 50		//Player zombie's vision tint
hea_points 1		//Points gained for killing Head Crabs
zom_points 2		//Points gained for killing Zombies
pla_points 3		//Points gained for killing Players (Humans/Zombies)
round_points 4		//Points gained for surviving the round as a human
rehl_sounds 1		//Enables death sounds
rehl_minplayers 2	//Min number of players needed to start gaining points
rehl_save 1		//Enables points saving
rehl_saveby 0		//0 = SteamID, 1 = IP, Else = Name
	
rehl_top15_path "addons/amxmodx/rehl_top15"	//The path where top15 files should be saved
*/

#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <fun>
#include <cstrike>
#include <fakemeta>
#include <hamsandwich>
#include <nvault>

#define PLUGIN "Resident Evil: Half-Life"
#define VERSION "1.0"
#define AUTHOR "Sam Tsuki"

#define VAULTNAME "rehl_mod"

#define TASKID_BALANCETEAM 	375

#define SKYNAME "space"

new rehl_switch, rehl_lightning, rehl_freezetime, rehl_roundtime, rehl_startmoney, camp_time, move_dist, rehl_heanum, camp_headcrabs, rehl_sounds, rehl_minplayers
new rehl_save, rehl_saveby, rehl_top15_path
new gVaultHandle
new top15_names[15][32], top15_authid[15][32], top15_points[15]
new knife_speed, rehl_unlimitedammo
new zombie_health, zombie_gravity, zombie_armor, zombie_speed, zombie_damage, zombie_vision, zombie_tint
new g_zombie[33]
new g_autoteam, g_limitteams, g_flashlight, g_freezetime, Float:g_buytime, g_roundtime, g_startmoney, g_fwd_spawn
new rehl_points[33], hea_points, zom_points, pla_points, round_points
new MsgSetFOV, gmsgDeathMsg, msgtext, saytext
new round_started = 0
new player_model[33][31]
new gPlayerPosition[33][3], gMoveTimer[33]
new dx, dy, dz, origin[3]
//--------------------------------------------------------------------------------------------------
public plugin_precache() 
{
	precache_model("models/player/mysticdeath_zombie/mysticdeath_zombie.mdl")
	precache_model("models/rehl_mod/zombie_knife.mdl")
	precache_sound("rehl_mod/ambience.wav")
	precache_sound("scientist/scream1.wav")
	precache_sound("scientist/scream2.wav")
	precache_sound("scientist/scream5.wav")
	precache_sound("zombie/zo_pain1.wav")
	precache_sound("zombie/zo_pain2.wav")
	
	g_fwd_spawn = register_forward(FM_Spawn, "fwd_spawn")
}
//--------------------------------------------------------------------------------------------------
public plugin_init() 
{
	register_plugin(PLUGIN, VERSION, AUTHOR)
	
	rehl_switch = register_cvar("rehl_switch","1")
	rehl_lightning = register_cvar("rehl_lightning", "2")
	rehl_freezetime = register_cvar("rehl_freezetime", "10")
	rehl_roundtime = register_cvar("rehl_roundtime", "3")
	rehl_startmoney = register_cvar("rehl_startmoney", "16000")
	camp_time = register_cvar("camp_time", "15")
	move_dist = register_cvar("move_dist", "150")
	rehl_heanum = register_cvar("rehl_heanum", "3")
	camp_headcrabs = register_cvar("camp_headcrabs", "1")
	knife_speed = register_cvar("knife_speed", "300")
	rehl_unlimitedammo = register_cvar("rehl_unlimitedammo", "1")
	zombie_health = register_cvar("zombie_health", "300")
	zombie_gravity = register_cvar("zombie_gravity", "0.5")
	zombie_armor = register_cvar("zombie_armor", "100.0")
	zombie_speed = register_cvar("zombie_speed", "300.0")
	zombie_damage = register_cvar("zombie_damage", "2.5")
	zombie_vision = register_cvar("zombie_vision", "130")
	zombie_tint = register_cvar("zombie_tint", "50")
	hea_points = register_cvar("hea_points", "1")
	zom_points = register_cvar("zom_points", "2")
	pla_points = register_cvar("pla_points", "3")
	round_points = register_cvar("round_points", "4")
	rehl_sounds = register_cvar("rehl_sounds", "1")
	rehl_minplayers = register_cvar("rehl_minplayers", "2")
	rehl_save = register_cvar("rehl_save", "1")
	rehl_saveby = register_cvar("rehl_saveby", "0")
	
	rehl_top15_path = register_cvar("rehl_top15_path", "addons/amxmodx/rehl_top15")
	
	RegisterHam(Ham_Killed, "func_wall", "monster_killed")
	
	unregister_forward(FM_Spawn, g_fwd_spawn)
	
	register_clcmd("say /points", "rehl_show_points")
	register_clcmd("say /save", "SaveScore")
	register_clcmd("say /load", "LoadScore")
	register_clcmd("say /rehl_top15", "show_top15")
	register_clcmd("say /models", "models_menu")
	
	register_clcmd("say_team /points", "rehl_show_points")
	register_clcmd("say_team /save", "SaveScore")
	register_clcmd("say_team /load", "LoadScore")
	register_clcmd("say_team /rehl_top15", "show_top15")
	register_clcmd("say-team /models", "models_menu")
	
	register_concmd("rehl_toggle", "rehlonoff", ADMIN_BAN, "<0|1> Disable/Enable Resident Evil: Half-Life")
	
	register_menucmd(register_menuid("Models Menu"),1023,"action_menu")
	
	server_cmd("sv_skyname %s", SKYNAME)
	
	set_task(1.0, "lightning_effects")
	set_task(1.0, "ambience_loop")
	set_task(1.0,"camp_check",0,"",0,"b")
	set_task(get_pcvar_float(rehl_freezetime), "rehl_start")
	
	register_event("DeathMsg", "rehl_death", "a")
	register_event("HLTV", "event_newround", "a", "1=0", "2=0")
	register_event("ResetHUD","rehl_newspawn","b")
	register_event("CurWeapon", "rehl_weapons", "b")
	register_event("Damage", "rehl_zombie_damage", "b")
	
	register_logevent("logevent_round_end",   2, "1=Round_End")
	
	register_think("func_wall","think_wall")
	
	MsgSetFOV = get_user_msgid("SetFOV")
	gmsgDeathMsg = get_user_msgid("DeathMsg")
	msgtext = get_user_msgid("StatusText")
	saytext = get_user_msgid("SayText")
	
	read_top15()
	set_task(1.0,"unlimited_ammo",0,"",0,"b")
}
//--------------------------------------------------------------------------------------------------
public plugin_cfg()
{
	new configsdir[128]
	get_configsdir(configsdir, 127)
	
	new file[256]
	format(file, 63, "%s/rehl_mod/rehl_mod.cfg", configsdir)
	
	if(file_exists(file))
		server_cmd("exec %s", file)
	
	g_autoteam = get_cvar_num("mp_autoteambalance")
	g_limitteams = get_cvar_num("mp_limitteams")
	g_flashlight = get_cvar_num("mp_flashlight")
	g_freezetime = get_cvar_num("mp_freezetime")
	g_buytime = get_cvar_float("mp_buytime")
	g_roundtime = get_cvar_num("mp_roundtime")
	g_startmoney = get_cvar_num("mp_startmoney")
	
	set_cvar_num("mp_autoteambalance",0)
	set_cvar_num("mp_limitteams", 1)
	set_cvar_num("mp_flashlight", 1)
	set_cvar_num("mp_freezetime", get_pcvar_num(rehl_freezetime))
	set_cvar_float("mp_buytime", get_pcvar_num(rehl_freezetime) * 0.0166)
	set_cvar_num("mp_roundtime", get_pcvar_num(rehl_roundtime))
	set_cvar_num("mp_startmoney", get_pcvar_num(rehl_startmoney))
	set_cvar_num("sv_restart", 1)
}
//--------------------------------------------------------------------------------------------------
public fwd_spawn(ent)
{
	if(!pev_valid(ent)) 
		return FMRES_IGNORED
	
	static objective_ents[][] = 
	{ 
		"func_bomb_target",    "info_bomb_target", 
		"hostage_entity",      "monster_scientist", 
		"func_hostage_rescue", "info_hostage_rescue",
		"info_vip_start",      "func_vip_safetyzone", 
		"func_escapezone"
	}

	static classname[32], i
	pev(ent, pev_classname, classname, 31)

	for(i = 0; i < sizeof objective_ents; i++)
	{
		if(equal(classname, objective_ents[i]))
		{
			engfunc(EngFunc_RemoveEntity, ent)
			return FMRES_SUPERCEDE
		}
	}
	return FMRES_IGNORED
}
//--------------------------------------------------------------------------------------------------
public think_wall(ent)
{
	if(!pev_valid(ent))
		return PLUGIN_HANDLED
	
	if(!get_pcvar_num(rehl_switch) || !round_started)
		engfunc(EngFunc_RemoveEntity, ent)
	return PLUGIN_CONTINUE
}
//--------------------------------------------------------------------------------------------------
public SaveScore(id)
{
	if (get_pcvar_num(rehl_save) == 0) return PLUGIN_HANDLED
	
	new authid[32]
	if (get_pcvar_num(rehl_saveby) == 0)
		get_user_authid(id, authid, 31)
	else if (get_pcvar_num(rehl_saveby) == 1)
		get_user_ip(id, authid, 31, 1)
	else
		get_user_name(id, authid, 31)

	new vaultkey[64], vaultdata[64] 
	
	gVaultHandle = nvault_open(VAULTNAME)
  
	format(vaultkey, 63, "REHL-%s-points", authid) 
	format(vaultdata, 63, "%d", rehl_points[id])
	nvault_set(gVaultHandle, vaultkey, vaultdata)

	new msg[250]
	format(msg, 249, "^x04[RE:HL Mod] ^x01Score Saved!")
	colored_msg(id, msg, MSG_ONE, saytext)
	format(msg, 249, "^x04[RE:HL Mod] ^x01You have '^x03%d^x01' Points!", rehl_points[id])
	colored_msg(id, msg, MSG_ONE, saytext)
		
	nvault_close(gVaultHandle)
	
	check_top15(id)
	
	return PLUGIN_HANDLED
}
//--------------------------------------------------------------------------------------------------
public LoadScore(id)
{
	if (get_pcvar_num(rehl_save) == 0) return PLUGIN_HANDLED
	
	new authid[32]
	if (get_pcvar_num(rehl_saveby) == 0)
		get_user_authid(id, authid, 31)
	else if (get_pcvar_num(rehl_saveby) == 1)
		get_user_ip(id, authid, 31, 1)
	else
		get_user_name(id, authid, 31)

	new vaultkey[64], vaultdata[64] 
	
	gVaultHandle = nvault_open(VAULTNAME)
  
	format(vaultkey, 63, "REHL-%s-points", authid) 
	nvault_get(gVaultHandle, vaultkey, vaultdata, 63)
	rehl_points[id] = str_to_num(vaultdata)
	
	new msg[250]
	format(msg, 249, "^x04[RE:HL Mod] ^x01Score Loaded!")
	colored_msg(id, msg, MSG_ONE, saytext)
	format(msg, 249, "^x04[RE:HL Mod] ^x01You have '^x03%d^x01' Points!", rehl_points[id])
	colored_msg(id, msg, MSG_ONE, saytext)
	
	nvault_close(gVaultHandle)
	
	return PLUGIN_HANDLED
}
//--------------------------------------------------------------------------------------------------
public client_connect(id)
{
	LoadScore(id)
}
//--------------------------------------------------------------------------------------------------
public client_disconnect(id)
{
	SaveScore(id)
}
//--------------------------------------------------------------------------------------------------
public client_PreThink(id)
{
	new clip, ammo, wpn = get_user_weapon(id, clip, ammo)
		
	new sModel[32]
	pev(id, pev_viewmodel2, sModel, 31)
	if (wpn == CSW_KNIFE && !g_zombie[id]) {
		if (equali(sModel, "models/v_knife.mdl", 0)){
			set_pev(id, pev_viewmodel2, "")
			set_pev(id, pev_weaponmodel2, "")
		}
		entity_set_int(id, EV_INT_button, entity_get_int(id,EV_INT_button) & ~IN_ATTACK)
		entity_set_int(id, EV_INT_button, entity_get_int(id,EV_INT_button) & ~IN_ATTACK2)
	}
}
//--------------------------------------------------------------------------------------------------
public read_top15() {
	for( new i = 0 ; i < 15; ++i) {
		top15_names[i] = ""
		top15_points[i] = 0
		top15_authid[i] = ""
	}
	
	new pathname[128]
	get_pcvar_string(rehl_top15_path,pathname,127)
	
	new filename[128]	
	format(filename, 127, "%s/relh_top15.txt", pathname)
		
	if( file_exists(filename) ) { 
		new number[192], line = 0, txtsize = 0
		for( new i = 0 ; i < 10; i++ ) {
			if( (line=read_file(filename,line,top15_authid[i],32,txtsize))!=0 ) {
				if( (line=read_file(filename,line,top15_names[i],32,txtsize))!=0 ) {
					if( (line=read_file(filename,line,number,191,txtsize))!=0 )  {
						top15_points[i] = str_to_num( number )
					}
				}
			}
		}		
	}
	
	return PLUGIN_HANDLED
}
//--------------------------------------------------------------------------------------------------
public save_top15() {
	new pathname[128]
	get_pcvar_string(rehl_top15_path,pathname,127)
	
	new filename[128]	
	format(filename, 127, "%s/rehl_top15.txt", pathname)
		
	if( file_exists(filename) )  
		delete_file(filename)
	
	for( new i = 0; i < 15; i++ ) {
		
		new number[192]
		num_to_str(top15_points[i],number,191)
		
		write_file(filename, top15_authid[i])
		write_file(filename, top15_names[i])		
		write_file(filename, number)			
	}	
}
//--------------------------------------------------------------------------------------------------
public show_top15(id) { 
	new buffer[2048] 
	new line[256]
		
	new len = format( buffer, 2047, "<body bgcolor=#000000><font color=#FFB000><pre>" )
	
	len += format( buffer[len], 2047-len, "<table cellspacing=10 rules=all border=0 frame=border>" )
	len += format( buffer[len], 2047-len, "<tr><td><font color=#FFB000><B> # <td><font color=#FFB000><B> Player Name <td><font color=#FFB000><B> Points" )
		
	for(new i = 0; i < 15; ++i) {
		format(line, 255, "<tr><td><font color=#FFB000> %d. <td><font color=#FFB000> %s <td><font color=#FFB000> %d", (i+1), top15_names[i], top15_points[i])
							
		len += format( buffer[len], 2047-len, line )
	}
	
	format(line, 255, "</table>" )
	len += format( buffer[len], 2047-len, line )
		
	show_motd( id, buffer, "Resident Evil: Half-life Top 15" )  
	return PLUGIN_HANDLED 	
} 
//--------------------------------------------------------------------------------------------------
public check_top15(id) {
	new name[32]
	get_user_name( id, name, 31 )
	
	new authid[32]
	if (rehl_saveby == 0)
		get_user_authid(id, authid, 31)
	else if (rehl_saveby == 1)
		get_user_ip(id, authid, 31, 1)
	else
		get_user_name(id, authid, 31)

	if( rehl_points[id] > top15_points[14] ) {
		for( new i = 0; i < 10; i++ ) {
			if( rehl_points[id] > top15_points[i] ) {
				new pos = i
				while( !equal( top15_authid[pos], authid ) && pos < 14 )
					pos++
				for( new j = pos; j > i; j-- ) {
					format( top15_authid[j], 32, top15_authid[j-1] )
					format( top15_names[j], 32, top15_names[j-1] )
					top15_points[j] = top15_points[j-1]
				}
			
				format( top15_authid[i], 32, authid )
				format( top15_names[i], 32, name )
				top15_points[i] = rehl_points[id]
			
				break
			}
			else if( equal( top15_authid[i], authid ) )
				break
		}	
	}
	save_top15()
}
//--------------------------------------------------------------------------------------------------
stock setScreenFlash(id, red, green, blue, decisecs, alpha)
{
	if (!is_user_connected(id)) return
	message_begin(MSG_ONE,get_user_msgid("ScreenFade"),{0,0,0},id)
	write_short( 1<<decisecs ) // fade lasts this long duration
	write_short( 1<<decisecs ) // fade lasts this long hold time
	write_short( 1<<12 ) // fade type (in / out)
	write_byte( red ) // fade red
	write_byte( green ) // fade green
	write_byte( blue ) // fade blue
	write_byte( alpha ) // fade alpha
	message_end()
}
//--------------------------------------------------------------------------------------------------
stock g_MaxBPAmmo[] = {
	0,
	52,	//CSW_P228
	0,
	90,	//CSW_SCOUT
	1,	//CSW_HEGRENADE
	32,	//CSW_XM1014
	1,	//CSW_C4
	100,//CSW_MAC10
	90,	//CSW_AUG
	1,	//CSW_SMOKEGRENADE
	120,//CSW_ELITE
	100,//CSW_FIVESEVEN
	100,//CSW_UMP45
	90,	//CSW_SG550
	90,	//CSW_GALIL
	90,	//CSW_FAMAS
	100,//CSW_USP
	120,//CSW_GLOCK18
	30,	//CSW_AWP
	120,//CSW_MP5NAVY
	200,//CSW_M249
	32,	//CSW_M3
	90,	//CSW_M4A1
	120,//CSW_TMP
	90,	//CSW_G3SG1
	2,	//CSW_FLASHBANG
	35,	//CSW_DEAGLE
	90,	//CSW_SG552
	90,	//CSW_AK47
	0,	//CSW_KNIFE
	100//CSW_P90
}
//--------------------------------------------------------------------------------------------------
public unlimited_ammo()
{
	if(!get_pcvar_num(rehl_switch) || !get_pcvar_num(rehl_unlimitedammo))
		return PLUGIN_HANDLED
	
	new maxplayers = get_maxplayers()
	for(new id = 1; id <= maxplayers; id++) {
		if(!g_zombie[id]) {
			new clip, ammo, wpnid = get_user_weapon(id, clip, ammo)
			if (wpnid > 0) {
				new bpammo = g_MaxBPAmmo[wpnid]
				if (bpammo)
				{
					cs_set_user_bpammo(id, wpnid, bpammo)
				}
			}
		}
	}
	return PLUGIN_HANDLED
}
//--------------------------------------------------------------------------------------------------
public rehl_show_points(id)
{
	if(!get_pcvar_num(rehl_switch))
		return PLUGIN_HANDLED
	
	new msg[250]
	format(msg, 249, "^x04[RE:HL Mod] ^x01You have '^x03%d^x01' Points!", rehl_points[id])
	colored_msg(id, msg, MSG_ONE, saytext)
	return PLUGIN_CONTINUE
}
//--------------------------------------------------------------------------------------------------
public models_menu(id)
{
	if(g_zombie[id]) {
		new msg[250]
		format(msg, 249, "^x04[RE:HL Mod] ^x01Zombies can't change their model!")
		colored_msg(id, msg, MSG_ONE, saytext)
		return PLUGIN_HANDLED
	}
	
	cs_get_user_model(id, player_model[id], 20)
	
	new menu_body[320]
	new n = 0
	new len = 319

	n += format( menu_body[n],len-n,"\yModels Menu:^n^n\w")

	if ( equal(player_model[id], "urban") ) {
		n += format( menu_body[n],len-n,"\r1. Urban^n\w")
	}
	else {
		n += format( menu_body[n],len-n,"1. Urban^n")
	}
	
	if ( equal(player_model[id], "gsg9") ) {
		n += format( menu_body[n],len-n,"\r2. Gsg9^n\w")
	}
	else {
		n += format( menu_body[n],len-n,"2. Gsg9^n")
	}
	
	if ( equal(player_model[id], "sas") ) {
		n += format( menu_body[n],len-n,"\r3. Sas^n\w")
	}
	else {
		n += format( menu_body[n],len-n,"3. Sas^n")
	}
	
	if ( equal(player_model[id], "gign") ) {
		n += format( menu_body[n],len-n,"\r4. Gign^n\w")
	}
	else {
		n += format( menu_body[n],len-n,"4. Gign^n")
	}
	
	if ( equal(player_model[id], "terror") ) {
		n += format( menu_body[n],len-n,"\r5. Terror^n\w")
	}
	else {
		n += format( menu_body[n],len-n,"5. Terror^n")
	}
	
	if ( equal(player_model[id], "leet") ) {
		n += format( menu_body[n],len-n,"\r6. Leet^n\w")
	}
	else {
		n += format( menu_body[n],len-n,"6. Leet^n")
	}
	
	if ( equal(player_model[id], "arctic") ) {
		n += format( menu_body[n],len-n,"\r7. Arctic^n\w")
	}
	else {
		n += format( menu_body[n],len-n,"7. Arctic^n")
	}
	
	if ( equal(player_model[id], "guerilla") ) {
		n += format( menu_body[n],len-n,"\r8. Guerilla^n\w")
	}
	else {
		n += format( menu_body[n],len-n,"8. Guerilla^n")
	}
	
	n += format( menu_body[n],len-n,"\y^n0. Exit")

	new keys = (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<9)

	show_menu(id,keys,menu_body)
	return PLUGIN_HANDLED
}
//--------------------------------------------------------------------------------------------------
public action_menu(id,key)
{
	if(g_zombie[id])
		return PLUGIN_HANDLED
	
	key++
	
	switch(key) {
		case 1: cs_set_user_model(id, "urban")
		case 2: cs_set_user_model(id, "gsg9")
		case 3: cs_set_user_model(id, "sas")
		case 4: cs_set_user_model(id, "gign")
		case 5: cs_set_user_model(id, "terror")
		case 6: cs_set_user_model(id, "leet")
		case 7: cs_set_user_model(id, "arctic")
		case 8: cs_set_user_model(id, "guerilla")
		case 10: return PLUGIN_HANDLED
		default:{
			models_menu(id)
			return PLUGIN_HANDLED
		}
	}
	
	cs_get_user_model(id, player_model[id], 20)
	new msg[250]
	format(msg, 249, "^x04[RE:HL Mod]^x01 Your model is now '^x03%s^x01'", player_model[id])
	colored_msg(id, msg, MSG_ONE, saytext)
	return PLUGIN_HANDLED
}
//--------------------------------------------------------------------------------------------------
public monster_killed(this, idattacker, shouldgib)
{
	if(!get_pcvar_num(rehl_switch) || !round_started || g_zombie[idattacker])
		return HAM_IGNORED
	
	new players[32], players_count
	get_players(players, players_count) 
	if (players_count < get_pcvar_num(rehl_minplayers))
		return HAM_IGNORED
	
	//make sure player is connected
	if (is_user_connected(idattacker))
	{
		if(!pev_valid(this))
			return HAM_IGNORED
		
		new monmodel[31]
		new monster[21], points
		entity_get_string(this, EV_SZ_model, monmodel, 30)
		if(equal(monmodel, "models/headcrab.mdl")) {
			monster = "Head Crab"
			points = get_pcvar_num(hea_points)
		}
		else if(equal(monmodel, "models/zombie.mdl")) {
			monster = "Zombie"
			points = get_pcvar_num(zom_points)
		}
		else return HAM_IGNORED
		
		rehl_points[idattacker] += points
		new frags = get_user_frags(idattacker) + 1
		set_user_frags(idattacker, frags)
		new msg[250]
		format(msg, 249, "^x04[RE:HL Mod] ^x01You got '^x03%d^x01' points for killing a '^x04%s^x01'!", points, monster)
		colored_msg(idattacker, msg, MSG_ONE, saytext)
		cs_set_user_deaths(idattacker, cs_get_user_deaths(idattacker))
		remove_entity(this)
	}
	return HAM_HANDLED
}
//--------------------------------------------------------------------------------------------------
public colored_msg(id, msg[], msgtype, msgt)
{ 
	message_begin(msgtype, msgt, {0,0,0}, id)
	write_byte(id)
	write_string(msg)
	message_end() 
}
//--------------------------------------------------------------------------------------------------
public rehl_newspawn(id)
{
	if(!get_pcvar_num(rehl_switch))
		return PLUGIN_HANDLED
		
	if ( round_started == 0 ) {
		if ( g_zombie[id] ) {
			cs_set_user_armor(id, 0, CS_ARMOR_NONE)
			g_zombie[id] = false
			cs_set_user_model(id,player_model[id])
		}
	}
	return PLUGIN_HANDLED
}
//--------------------------------------------------------------------------------------------------
public rehl_start()
{
	if(!get_pcvar_num(rehl_switch))
		return PLUGIN_HANDLED
		
	round_started = 1
	new CsTeams:player_team
	new maxplayers = get_maxplayers()
	for (new i = 1; i <= maxplayers; i++) 
	{
		player_team = cs_get_user_team(i)
		if(player_team == CS_TEAM_T) {
			cs_get_user_model(i, player_model[i], 31)
			cs_set_user_team(i, CS_TEAM_CT, CS_DONTCHANGE)
			cs_set_user_model(i, player_model[i])
		}
	}
	return PLUGIN_CONTINUE
}
//--------------------------------------------------------------------------------------------------
public camp_check()
{
	if(!get_pcvar_num(rehl_switch) || get_pcvar_num(camp_headcrabs) == 0 || round_started == 0)
		return PLUGIN_HANDLED

	// Check all players to see if they've moved...

	for ( new i = 1; i <= 32; i++ ) {

		if (!is_user_alive(i)) continue
		
		get_user_origin(i,origin)
		
		dx = gPlayerPosition[i][0] - origin[0]
		dy = gPlayerPosition[i][1] - origin[1]
		dz = gPlayerPosition[i][2] - origin[2]
		new d = sqrt( dx*dx + dy*dy + dz*dz )
		if (d <= get_pcvar_num(move_dist)) {
			gMoveTimer[i]++
			if ( gMoveTimer[i]>get_pcvar_num(camp_time) && !g_zombie[i] ) {
				gMoveTimer[i] = 0
				camp_summon(i)
			}
		}
		else {
			gMoveTimer[i] = 0
		}
		gPlayerPosition[i][0] = origin[0]
		gPlayerPosition[i][1] = origin[1]
		gPlayerPosition[i][2] = origin[2]
	}
	return PLUGIN_CONTINUE
}
//--------------------------------------------------------------------------------------------------
stock sqrt(num)
{
	if (num > 0)	return sqroot(num)
	return 0
}
//--------------------------------------------------------------------------------------------------
public camp_summon(id)
{
	if(!get_pcvar_num(rehl_switch))
		return PLUGIN_HANDLED
		
	for(new i = 1;i <= get_pcvar_num(rehl_heanum); i++) {
		set_task(i*0.2, "summon", id)
	}
	return PLUGIN_CONTINUE
}
//--------------------------------------------------------------------------------------------------
public summon(id)
{
	server_cmd("monster headcrab #%i", id)
}
//--------------------------------------------------------------------------------------------------
public rehl_zombie_damage(id) {
	if(!get_pcvar_num(rehl_switch))
		return PLUGIN_HANDLED
		
	if (!is_user_alive(id)) return PLUGIN_HANDLED
	
	new damage = read_data(2)
	new dmgtype = read_data(3)
	new weapon, bodypart, attacker = get_user_attacker(id,weapon,bodypart)
	
	new maxplayers = get_maxplayers()
	if ( attacker <= 0 || attacker > maxplayers ) return PLUGIN_HANDLED
	
	if ( g_zombie[attacker] && is_user_alive(id) && id != attacker ) {
		//Extra Damage
		new extraDamage = floatround(damage * get_pcvar_float(zombie_damage) - damage)
		new namek[32],namev[32],authida[35],authidv[35],teama[32],teamv[32]
		get_user_name(id,namev,31)
		get_user_name(attacker,namek,31)
		get_user_authid(id,authidv,34)
		get_user_authid(attacker,authida,34)
		get_user_team(id,teamv,31)
		get_user_team(attacker,teama,31)

		new Float:fl_dmg = float(extraDamage)
		
		if(extraDamage >= get_user_health(id)) {
			set_msg_block(gmsgDeathMsg,BLOCK_SET)
			fakedamage(id, "weapon_knife", fl_dmg, dmgtype)
			set_msg_block(gmsgDeathMsg,BLOCK_NOT)
			
			if(is_user_alive(id))
				return PLUGIN_HANDLED
			
			message_begin(MSG_ALL, get_user_msgid("DeathMsg"), {0,0,0}, 0)
			write_byte(attacker)
			write_byte(id)
			write_byte(0)
			write_string("zombie")
			message_end()
		
			new money = cs_get_user_money(attacker)
			cs_set_user_money(attacker, money + 300) // award for kill

			set_user_frags(attacker,get_user_frags(attacker) + 1 )
			//set_user_frags(attacker,get_user_frags(victim) + 1 )
			log_message("^"%s<%d><%s><%s>^" killed ^"%s<%d><%s><%s>^" with ^"zombie^"",
			namek,get_user_userid(attacker),authida,teama,namev,get_user_userid(id),authidv,teamv)
		}
		else
		{
			fakedamage(id, "weapon_knife", fl_dmg, dmgtype) //set_user_health(victim,get_user_health(victim) - damage )
		}
	}
	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public rehl_weapons(id) {
	if(!get_pcvar_num(rehl_switch))
		return PLUGIN_HANDLED
	
	if(!g_zombie[id]) {
		set_task(0.2, "knife_check", id)
		return PLUGIN_HANDLED
	}
	
	rehl_set_atrib(id)
	return PLUGIN_CONTINUE
}
//--------------------------------------------------------------------------------------------------
public knife_check(id)
{
	new clip, ammo, wpn = get_user_weapon(id, clip, ammo)
	if(wpn == CSW_KNIFE) {
		set_user_maxspeed(id, get_pcvar_float(knife_speed))
	}
}
//----------------------------------------------------------------------------------------------
public rehl_death()
{
	if(!get_pcvar_num(rehl_switch))
		return PLUGIN_HANDLED
	
	new players[32], players_count
	get_players(players, players_count) 
	if (players_count < get_pcvar_num(rehl_minplayers))
		return PLUGIN_HANDLED
	
	new killer = read_data(1)
	new id = read_data(2)

	if ( round_started == 0 ) return PLUGIN_HANDLED
	if ( !is_user_connected(id) || is_user_alive(id) ) return PLUGIN_HANDLED
	if ( g_zombie[id] ) {
		new die = random_num(1, 2)
		switch(die) {
			case 1: emit_sound(id, CHAN_STATIC, "zmobie/zo_pain1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			case 2: emit_sound(id, CHAN_STATIC, "scientist/zo_pain2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
		return PLUGIN_HANDLED
	}

	if(get_pcvar_num(rehl_sounds) == 1) {
		new die = random_num(1, 3)
		switch(die) {
			case 1: emit_sound(id, CHAN_STATIC, "scientist/scream1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			case 2: emit_sound(id, CHAN_STATIC, "scientist/scream2.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			case 3: emit_sound(id, CHAN_STATIC, "scientist/scream5.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		}
	}
	
	new parm[2]
	parm[0] = id
	set_task(0.2,"rehl_summon", 0, parm, 1)
	new maxplayers = get_maxplayers()
	if(!killer || killer > maxplayers || killer == id) return PLUGIN_HANDLED
	new points = get_pcvar_num(pla_points)
	rehl_points[killer] += points
	new name[32]
	get_user_name(id, name, 31)
	new msg[250]
	format(msg, 249, "^x04[RE:HL Mod] ^x01You got '^x03%d^x01' points for killing '^x03%s^x01'!", points, name)
	colored_msg(killer, msg, MSG_ONE, saytext)
	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public rehl_summon(parm[])
{
	if(!get_pcvar_num(rehl_switch))
		return PLUGIN_HANDLED
		
	new dead = parm[0]

	if ( round_started == 0 ) return PLUGIN_HANDLED
	if ( !is_user_connected(dead)) return PLUGIN_HANDLED
	if ( is_user_alive(dead) ) return PLUGIN_HANDLED
	
	cs_set_user_team(dead, CS_TEAM_T)
	cs_user_spawn(dead)
	cs_user_spawn(dead)
	
	g_zombie[dead] = true
	set_entity_flags(dead, FL_NOTARGET, 1)
	cs_set_user_model(dead, "mysticdeath_zombie")
	set_user_health(dead,get_pcvar_num(zombie_health))
	set_user_gravity(dead,get_pcvar_float(zombie_gravity))
	cs_set_user_armor(dead,get_pcvar_num(zombie_armor),CS_ARMOR_VESTHELM)
	rehl_set_atrib(dead)
	setScreenFlash(dead, 255, 10, 10, 10, 255)
	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public rehl_set_atrib(id) {
	if(!get_pcvar_num(rehl_switch))
		return PLUGIN_HANDLED
		
	if(!is_user_alive(id) || !g_zombie[id]) return PLUGIN_HANDLED
	
	new ammo, clip, wpnid = get_user_weapon(id, ammo, clip)
	
	if(wpnid != CSW_KNIFE) {
		engclient_cmd(id, "weapon_knife")
	}
	
	entity_set_string(id, EV_SZ_viewmodel,"models/rehl_mod/zombie_knife.mdl")
	set_pev(id, pev_weaponmodel2, "")
	cs_set_user_model(id, "mysticdeath_zombie")
	set_user_maxspeed(id, get_pcvar_float(zombie_speed))
	
	// Prevent cvar from being set too low
	new Zoom = get_pcvar_num(zombie_vision)

	if ( Zoom < 100 )
	{
		Zoom = 100
		set_pcvar_num(zombie_vision, Zoom)
	}

	// Set Zoom
	message_begin(MSG_ONE, MsgSetFOV, {0,0,0}, id)
	write_byte(Zoom)
	message_end()
	
	set_entity_flags(id, FL_NOTARGET, 1)
	
	set_task(0.5, "zombie_vision_loop", id, "", 0, "b")
	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public zombie_vision_loop(id) {
	if(!get_pcvar_num(rehl_switch))
		return PLUGIN_HANDLED
		
	if ( !is_user_connected(id) )
	{
		remove_task(id)
		return PLUGIN_HANDLED
	}

	if ( g_zombie[id] && is_user_alive(id) )
	{
		setScreenFlash(id, 255, 10, 10, 10, get_pcvar_num(zombie_tint))
		cs_set_user_model(id, "mysticdeath_zombie")
		set_user_maxspeed(id, get_pcvar_float(zombie_speed))
		new HUD[51]
		format(HUD,50,"Health: %i Armor: %i",get_user_health(id),get_user_armor(id))
		message_begin(MSG_ONE, msgtext, {0,0,0}, id)
		write_byte(0)
		write_string(HUD)
		message_end()
	}
	return PLUGIN_CONTINUE
}
//--------------------------------------------------------------------------------------------------
public event_newround()
{
	if(!get_pcvar_num(rehl_switch))
		return PLUGIN_HANDLED
		
	set_task(get_pcvar_float(rehl_freezetime), "rehl_start")
	return PLUGIN_CONTINUE
}
//--------------------------------------------------------------------------------------------------
public logevent_round_end()
{
	if(!get_pcvar_num(rehl_switch))
		return PLUGIN_HANDLED
		
	new maxplayers = get_maxplayers()
	for(new i = 1; i <= maxplayers; i++) {
		if(g_zombie[i])
			user_kill(i, 1)
		else if(is_user_alive(i))
			rehl_points[i] += get_pcvar_num(round_points)
	}
	
	round_started = 0
	remove_task(TASKID_BALANCETEAM)
	set_task(1.5, "task_balanceteam", TASKID_BALANCETEAM)
	return PLUGIN_CONTINUE
}
//--------------------------------------------------------------------------------------------------
public task_balanceteam()
{
	if(!get_pcvar_num(rehl_switch))
		return PLUGIN_HANDLED
		
	static players[CsTeams:3][32], count[CsTeams:3], i, id, CsTeams:team
	get_players(players[CS_TEAM_UNASSIGNED], count[CS_TEAM_UNASSIGNED])
	count[CS_TEAM_T] = 0, count[CS_TEAM_CT] = 0
	
	for(i = 0; i < count[CS_TEAM_UNASSIGNED]; i++)
	{
		id = players[CS_TEAM_UNASSIGNED][i], team = cs_get_user_team(id)
		if(team == CS_TEAM_T || team == CS_TEAM_CT)
			players[team][count[team]++] = id
	}

	if(abs(count[CS_TEAM_T] - count[CS_TEAM_CT]) <= 1) return PLUGIN_HANDLED

	static maxplayers; maxplayers = (count[CS_TEAM_T] + count[CS_TEAM_CT]) / 2
	if(count[CS_TEAM_T] > maxplayers)
	{
		for(i = 0; i < (count[CS_TEAM_T] - maxplayers); i++)
			cs_set_user_team(players[CS_TEAM_T][i], CS_TEAM_CT)
	}
	else
	{
		for(i = 0; i < (count[CS_TEAM_CT] - maxplayers); i++)
			cs_set_user_team(players[CS_TEAM_CT][i], CS_TEAM_T)
	}
	return PLUGIN_CONTINUE
}
//--------------------------------------------------------------------------------------------------
public lightning_effects() 
{
	if(!get_pcvar_num(rehl_switch))
		return PLUGIN_HANDLED
	
	if (get_pcvar_num(rehl_lightning) == 0)
	{	
		set_lights("#OFF")
		remove_task(12175)
		set_task(20.0,"lightning_effects")
	}
	else if (get_pcvar_num(rehl_lightning) == 1)
	{
		set_lights("a")
		set_task(random_float(10.0,17.0),"thunder_clap",12175)
	}
	else if (get_pcvar_num(rehl_lightning) == 2)
	{	
		set_lights("b")
		remove_task(12175)
		set_task(random_float(10.0,17.0),"thunder_clap",12175)
	}
	return PLUGIN_CONTINUE
}
//--------------------------------------------------------------------------------------------------
public thunder_clap() 
{
	if(!get_pcvar_num(rehl_switch))
		return PLUGIN_HANDLED
	
	set_lights("p")
	client_cmd(0,"speak ambience/thunder_clap.wav")
	
	set_task(1.25,"lightning_effects",12175)
	
	return PLUGIN_CONTINUE
}
//--------------------------------------------------------------------------------------------------
public rehlonoff(id,level,cid) 
{
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	
	new szArg[5]
	read_argv(1, szArg, 4)
	
	if (equali(szArg,"1") || equali(szArg,"on")) 
	{
		if (get_pcvar_num(rehl_switch) == 1) 
		{
			console_print(id, "%s is already on!", PLUGIN)
			return PLUGIN_HANDLED
		}
		
		rehl_on()
		
		set_hudmessage(255, 255, 255, -1.0, 0.25, 0, 1.0, 5.0, 0.1, 0.2, -1)
		show_hudmessage(0, "%s is now ON!", PLUGIN)
		
		console_print(0,  "%s has been turned ON!", PLUGIN)
		client_print(0, print_chat, "%s has been turned ON!", PLUGIN)
		
		return PLUGIN_HANDLED
	}
	
	if (equali(szArg,"0") || equali(szArg,"off")) 
	{
		if (get_pcvar_num(rehl_switch) == 0) 
		{
			console_print(id, "%s is already off!", PLUGIN)
			return PLUGIN_HANDLED
		}
		
		rehl_off()
		
		set_hudmessage(255, 255, 255, -1.0, 0.25, 0, 1.0, 5.0, 0.1, 0.2, -1)
		show_hudmessage(0, "%s has been turned OFF!", PLUGIN)
		
		console_print(0,  "%s has been turned OFF!", PLUGIN)
		client_print(0, print_chat, "%s has been turned OFF!", PLUGIN)
		
		return PLUGIN_HANDLED
	}
	
	console_print(id,  "Invalid argument!")
	client_print(id, print_chat, "Invalid argument!")
	
	return PLUGIN_HANDLED
}
//--------------------------------------------------------------------------------------------------
public rehl_on() 
{	
	new maxplayers = get_maxplayers()
	for (new i = 1; i <= maxplayers; i++) 
		g_zombie[i] = false
	
	set_pcvar_num(rehl_switch, 1)
	
	set_task(1.0, "lightning_effects")
	set_task(1.0, "ambience_loop")
	
	set_cvar_num("mp_autoteambalance",0)
	set_cvar_num("mp_limitteams", 1)
	set_cvar_num("mp_flashlight", 1)
	set_cvar_num("mp_freezetime", get_pcvar_num(rehl_freezetime))
	set_cvar_num("mp_freezetime", get_pcvar_num(rehl_freezetime))
	set_cvar_float("mp_buytime", get_pcvar_num(rehl_freezetime) * 0.0166)
	set_cvar_num("mp_roundtime", get_pcvar_num(rehl_roundtime))
	set_cvar_num("mp_startmoney", get_pcvar_num(rehl_startmoney))
	
	set_cvar_num("sv_restartround", 3)
}
//--------------------------------------------------------------------------------------------------
public rehl_off() 
{
	new maxplayers = get_maxplayers()
	for (new i = 1; i <= maxplayers; i++) {
		g_zombie[i] = false
		client_cmd(i, "stopsound")
	}
	
	set_pcvar_num(rehl_switch, 0)
	
	set_lights("#OFF")
	remove_task(12175)
	
	set_cvar_num("mp_autoteambalance",g_autoteam)
	set_cvar_num("mp_limitteams", g_limitteams)
	set_cvar_num("mp_flashlight", g_flashlight)
	set_cvar_num("mp_freezetime", g_freezetime)
	set_cvar_float("mp_buytime", g_buytime)
	set_cvar_num("mp_roundtime", g_roundtime)
	set_cvar_num("mp_startmoney", g_startmoney)
	
	set_cvar_num("sv_restartround", 3)
}
//--------------------------------------------------------------------------------------------------
public ambience_loop() 
{
	if(!get_pcvar_num(rehl_switch))
		return PLUGIN_HANDLED
	
	client_cmd(0,"spk rehl_mod/ambience.wav")
	
	set_task(17.0,"ambience_loop")
	
	return PLUGIN_CONTINUE
}
//--------------------------------------------------------------------------------------------------
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ fbidis\\ ansi\\ ansicpg1252\\ deff0{\\ fonttbl{\\ f0\\ fnil\\ fcharset0 Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ ltrpar\\ lang1025\\ f0\\ fs16 \n\\ par }
*/
